

#include "vistabar.h"

#include <qvariant.h>
#include <qlabel.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qiconview.h>
#include <qframe.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qdir.h>
#include <kdesktopfile.h>
#include <kiconloader.h>
#include <kmessagebox.h>
#include <kicontheme.h>
#include <kprocess.h>
#include <qheader.h>
#include <qfileinfo.h>
#include <kmessagebox.h>
#include <krun.h>
#include <kurl.h>
vista::vista (QWidget * parent, const char *name, WFlags fl):
QWidget (parent, name,
	 WStyle_Customize | WRepaintNoErase | WStyle_NoBorder |
	 WDestructiveClose)
{

  parentRef = parent;
  if (!name)
    setName ("vista");
  /*start top border */
  topbg = new QLabel (this, "topbg");
  topbg->setPixmap (QImage (top));
  topbg->setScaledContents (TRUE);
/*end top border */
  
  backbg = new QLabel (this, "backbg");
  backbg->setPixmap (QImage (bg));
  backbg->setScaledContents (TRUE);



/* tab's  */

  tab = new QTabWidget (this, "tabWidget2");
  tab->setPaletteBackgroundPixmap (QImage (bg));
  tab->setTabShape (QTabWidget::Rounded);

  widgetarray[0] = new QWidget (tab, "tab");

/*  */


/* icon view properties */
  list1 = new QListView (widgetarray[0], "List view");
  list1->header ()->hide ();
  list1->addColumn ("X");
  tab->insertTab (widgetarray[0], "All");

/* end icon view */

  botbg = new QLabel (this, "botbg");
//  botbg->setGeometry (QRect (-1, 368, 300, 35));
  botbg->setPixmap (QImage (bot));
  botbg->setScaledContents (TRUE);

 

  connect (list1, SIGNAL (selectionChanged ()), parent, SLOT (hide ()));
  // toolbars
 


  languageChange();
  clearWState (WState_Polished);
}

void
vista::createTab ()
{

  QDir menudir (apps);
  QStringList allfiles = menudir.entryList (QDir::Dirs);


  int j = 1;
  for (QStringList::Iterator i = allfiles.begin (); i != allfiles.end (); i++)
    {


      if (QString::compare (".", *i) != 0)
	{
	  if (QString::compare ("..", *i) != 0)
	    {
	      widgetarray[j] = new QWidget (tab, *i);
	      tab->insertTab (widgetarray[j], *i);

	      QDir apptype (apps + *i);
	      QStringList exefiles = apptype.entryList ("*.desktop");

	      listarray[j] = new QListView (widgetarray[j], "List view");
	      listarray[j]->header ()->hide ();
	      listarray[j]->addColumn ("X");

	      /* need this */

	      for (QStringList::Iterator r = exefiles.begin ();
		   r != exefiles.end (); r++)
		{
		  KDesktopFile applink (apps + *i + "/" + *r);

		  KIconLoader *iconload = KGlobal::iconLoader ();
		  QString iconfile =
		    iconload->iconPath (applink.readIcon (), KIcon::Desktop,
					false);
		  QListViewItem *tmp =
		    new QListViewItem (listarray[j], applink.readName ());
		  tmp->setPixmap (0, QPixmap (iconfile));
		}
/* */


	      connect (listarray[j],
		       SIGNAL (selectionChanged (QListViewItem *)), this,
		       SLOT (startApp (QListViewItem *)));
	      connect (listarray[j], SIGNAL (selectionChanged ()), parentRef,
		       SLOT (hide ()));
	      j++;

	    }
	}
    }

  numberoftabs = j;
}


/*
 *  Destroys the object and frees any allocated resources
 */
vista::~vista ()
{

}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void
vista::languageChange()
{
  setCaption (tr ("vista"));
//open a dir get the content
  QString path = QDir::homeDirPath () + QString ("/.kbfx/");
  apps = path + QString ("menu/");
  QDir dir = QDir::home ();
  int count = 0;
  if (!dir.exists (apps))
    {
      dir.mkdir (".kbfx");
      dir.mkdir (".kbfx/menu");
    }

  else
    {
      createTab ();

      QDir menudir (apps);
      files = menudir.entryList ("*.desktop");


      for (QStringList::Iterator i = files.begin (); i != files.end (); i++)
	{
	  KDesktopFile applink (apps + *i);
	  KIconLoader *iconload = KGlobal::iconLoader ();
	  QString iconfile =
	    iconload->iconPath (applink.readIcon (), KIcon::Desktop, false);
	  QListViewItem *tmp = new QListViewItem (list1, applink.readName ());
	  tmp->setPixmap (0, QPixmap (iconfile));
	}

    }
  connect (list1, SIGNAL (currentChanged (QListViewItem *)), this,
	   SLOT (startApp (QListViewItem *)));

  tab->changeTab (widgetarray[0], tr ("All"));
  //textLabel1->setText (tr ("<b>K-Menu</b>"));
  //textLabel2->setText (tr ("<b>logoff</b>"));
}


void
vista::startApp (QListViewItem * item)
{


  //  KMessageBox::information (0,("Start app slot"));
  QStringList desktopfiles;
  QDir dirs (apps);
  desktopfiles = dirs.entryList (QDir::All);

  for (QStringList::Iterator j = desktopfiles.begin ();
       j != desktopfiles.end (); j++)
    {

      QFileInfo fileinfo (apps + *j);
      QStringList exefiles;
      QString path (apps);
      exefiles = desktopfiles;
      if (fileinfo.isDir ())
	{
	  QDir incd (apps + *j);
	  exefiles = incd.entryList ("*.desktop");
	  path += *j + "/";
	  qWarning (path);
	}

      for (QStringList::Iterator i = exefiles.begin (); i != exefiles.end ();
	   ++i)
	{


	  KDesktopFile dfile (path + *i);
	  QString tmp (item->text (0));
	
	 if (tmp.compare (dfile.readName ()) == 0)
	    {
		KURL desktopfile;
		desktopfile.setPath(path + *i);
		KRun * exec = new  KRun(desktopfile);
		return; 
	    }


	}
    }
}


void vista::KAppBarSetTheme(QPixmap maintop, QPixmap mainbg , QPixmap tabbg , QPixmap mainbot,QPixmap mask){


int widthof;
int heightof;
if(!mask.isNull()){

	widthof = mask.width();
	heightof= mask.height();
  setMinimumWidth (widthof);
  setMinimumHeight (heightof);
 // this->setMask(*mask.mask());
  resize (QSize (mask.width(),mask.height()).expandedTo (minimumSizeHint ()));
}
else
{ 
  widthof = 300;
  heightof= 400;
  setMinimumWidth (300);
  setMinimumHeight (400);
  resize (QSize (300,400).expandedTo (minimumSizeHint ()));
}

	
topbg->setGeometry (QRect (-1, -1,widthof, maintop.height()));
backbg->setGeometry (QRect (0, maintop.height(),widthof,mainbg.height()));
botbg->setGeometry (QRect (0, ( ( heightof-(topbg->height()+mainbot.height())    )  +  (topbg->height())   )   ,widthof, mainbot.height()));
tab->setGeometry (QRect (( mask.width() - (tabbg.width()))/2 ,maintop.height()+5,(tabbg.isNull())?widthof-40:tabbg.width(),heightof-(topbg->height()+botbg->height()+5)));
list1->setGeometry (QRect (0, 0, tab->width(), tab->height()-30));

int x  = 1;
for (;x < numberoftabs ;x++)
     listarray[x]->setGeometry (QRect (0, 0, tab->width()-5, tab->height()-35));

	topbg->setPixmap ((maintop));
	backbg->setPixmap ((mainbg));
	botbg->setPixmap ((mainbot));
	tab->setPaletteBackgroundPixmap (tabbg);

}

